#!/usr/bin/env python3.7
# -*- coding: utf-8 -*-
"""
Version 2.0.2   Mai 2022 pour Bullseye
Mise en liste [] de tous les objets graphiques
Lecture sur plusieurs Raspi en SSH
Transfert des données par le fichier Thermo.dat
	0=Heure
	1=Config du capteur
	2=Pression hpa
	3=Pression cm
	4=Humidite
	5=Temperature
	6=Alarme Temperature
	7=Localisation
ENR MIN/MIN
	Fichier ThermoMM.dat
	0=Temp Min
	1=Date
	2=Heure
	3=Temp Max
	4=date
	5=heure
"""
import os,sys
import time
from time import sleep
from datetime import datetime
from tkinter import *
from tkinter import messagebox
from tkinter.scrolledtext import *
import subprocess
from subprocess import call
import pickle
from matplotlib import gridspec as gridspec
#from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg as FCTK
import matplotlib.pyplot as plt
import matplotlib.ticker as ticker
#import matplotlib.lines as mlines
import numpy as np
from functools import partial

ver='Thermo-Maitre-2.0.2'
"""Librairie générale"""
sys.path.append (sys.path[0] + "/Lib")
from Lib import clsSSH
SSH=clsSSH.SSH()

def Taillescreen():
	sc=os.popen("xrandr -q -d :0").readlines(1)[0]
	w=sc.split()[7]
	h=sc.split()[9][:-1]
	return w,h

def get_nom():
	cmd = "hostname | cut -d\' \' -f1"
	r=subprocess.check_output(cmd, shell=True).decode('utf-8')
	return str(r[:-1])

def get_LocalIP():
	cmd = "hostname -I | cut -d\' \' -f1"
	return str(call(cmd,shell=True))

def Lire_EXT(source):
	Voyant('white')
	if check[source].get() == 0:
		lab1[source].config(fg='grey')
		labCaptP1[source].config(text="***")
		labCaptP2[source].config(text="***")
		labCaptH[source].config(text="***")
		labCaptT[source].config(text="***")
		labHeure[source].config(text="***")
		labMin[source].config(text="Tmin:")
		labMax[source].config(text="Tmax:")

	else:
		capt[source][5]="Thermo.dat"
		try:
			d=SSH.Lire_tuple(capt[source],sep='|')
			if d[0] == "":
				lab1[source].config(text=capt[source][4] + " Pas de Capteur",font=('arial',12,'bold','underline'),fg='red')
				labCaptP1[source].config(text="---")
				labCaptP2[source].config(text="---")
				labCaptH[source].config(text="---")
				labCaptT[source].config(text="---")
				labHeure[source].config(text="---")
				labMin[source].config(text="Tmin:")
				labMax[source].config(text="Tmax:")
			else:
				h=" " + d[0]
				c="  (" + d[1] + ")"
				capt[source][4] = d[7]	#Localisation
				if capt[source][4] == "":
					capt[source][4]=NOMraspi[source]
				lab1[source].config(text=capt[source][4] + c,font=('arial',11,'bold','underline'),fg='black')
				labCaptP1[source].config(text=d[2] + " hPa")
				labCaptP2[source].config(text=d[3] + " cm")
				labCaptH[source].config(text=d[4] + " Hr%")
				if float(d[4][:-2]) > 70.0:
					labCaptH[source].config(fg='red')
				else:
					labCaptH[source].config(fg='blue')
				labCaptT[source].config(text=d[5] + " °c")
				if d[6] == "1":
					labCaptT[source].config(fg='magenta')
				else:
					labCaptT[source].config(fg='blue')
				labHeure[source].config(text=h)
				
				capt[source][5]="ThermoMM.dat"
				d=SSH.Lire_tuple(capt[source],sep='|')
				labMin[source].config(text="Tmin: " + d[0])
				labMax[source].config(text="Tmax: " + d[3])
				labMinD[source].config(text=d[1])
				labMaxD[source].config(text=d[4])
		except:
			return
	fen1.update()

def CDE_Temp():
	for c in range(0 ,NBcapt.get()):
		if check[c].get() and len(capt[c]) > 1:
			cmd=[capt[c][0],capt[c][1],capt[c][2],[]]
			labCPU[c].config(text=SSH.Nom_Raspi(cmd))
			t=SSH.CPUtemp(cmd)
			labCPUT[c].config(text=t + " °c")
			if float(t) > float(maxTcpu.get()):
				labCPUT[c].config(fg='red')
			else:
				labCPUT[c].config(fg='darkgreen')
	fen1.update()

def VNC(c):
	if check[c].get:
		cmd="vncviewer " + capt[c][0] + " &"
		call (cmd,shell=True)
	print ("\033c")

def MOIS_HISTO(e):
	global MoisHisto
	MoisHisto=listMH.curselection()[0]

def NOTICE(e):
	f=sys.path[0] + "/Thermo-Maitre-201.pdf"
	cmd="qpdfview " + f + " &"
	call (cmd,shell=True)
	#r=subprocess.check_output(cmd, shell=True).decode('utf-8')

def Lire_HISTO(c):
	#met le fichier en tableaux pour le graphe
	global histo0,histo1,histo2,histo3,histo4
	histo0,histo1,histo2,histo3,histo4 = [],[],[],[],[]

	if check[c].get():
		cmd=[capt[c][0],capt[c][1],capt[c][2],[]]
		nom=SSH.Nom_Raspi(cmd)
		capt[c][5]=VarAN.get() + "_" + nom + "_Thermo.dat"
		l=SSH.Lire_file(capt[c])
		ori=capt[c][4] + "  "  + listMH.get(MoisHisto) + "-" + VarAN.get()

	if len(l) > 0:
		for line in l:
			try:
				#On reforme un tuple à partir de la chaine
				#le champ 0 est année/mois
				t=[]
				t=tuple(map(str,line.split('|')))
				m=t[0]
				m=int(m[4:])
				if MoisHisto == 0:
					#Année entière   X=Jour/Mois
					histo0.append(t[0])
					histo1.append(t[1][:2] + "/" + str(m))
					histo2.append(float(t[2]))
					histo3.append(float(t[3]))
					histo4.append(float(t[4]))
				elif m == MoisHisto :
					#Mois       X=jour/heure
					histo0.append(t[0])
					histo1.append(t[1])
					histo2.append(float(t[2]))
					histo3.append(float(t[3]))
					histo4.append(float(t[4]))
			except:
				continue
		if len(histo0) > 1:
			GrapheHISTO(c,ori)
		else:
			messagebox.showinfo("**** HISTO ****",capt[c][5] + "\n PAS de DATA - " + VarAN.get() + "/" + ListeMois[MoisHisto])
	else:
		messagebox.showinfo("**** HISTO ****",capt[c][5] + "\n PAS de DATA")

def GrapheHISTO(c,ori=""):
	def GRAPHE3(ori):
		if len(histo1) > lissa:
			plt.subplot(131)
			x=np.array(histo1)
			y=np.array(histo4)
			coul="red"
			miny=min(y)
			maxy=max(y)
			plt.ylabel('°C',color=coul)
			plt.ylim(miny-0.5,maxy+0.5)
			plt.grid(which='major',axis='x',linewidth=1,linestyle='dashed',color='black')
			plt.grid(which='major',axis='y',linewidth=1,linestyle='-',color=coul)
			plt.suptitle(ori + "  Historique du " + x[0] + "  au " + x[len(x)-1] + "  [" + str(len(x)) + " points]",fontsize=12,fontweight='bold')
			if lissa > 0:
				mx,my=Lissage(x,y,lissa)
				plt.plot(x,y,'-',color='grey',label="Température")
				plt.plot(mx,my,'-',color=coul,label="Moy/" + str(lissa) + " Température",linewidth=2)
			else:
				plt.plot(x,y,'-',color=coul,label="Température")
			plt.legend(loc='upper left')

			plt.subplot(132)
			x=np.array(histo1)
			y=np.array(histo2)
			coul="green"
			miny=np.min(y)
			maxy=np.max(y)
			plt.ylabel("hPa",color=coul)
			plt.ylim(miny-5,maxy+5)
			plt.grid(which='major',axis='x',linewidth=1,linestyle='dashed',color='black')
			plt.grid(which='major',axis='y',linewidth=1,linestyle='-',color=coul)
			if lissa > 0:
				mx,my=Lissage(x,y,lissa)
				plt.plot(x,y,'-',color='grey',label="Pression")
				plt.plot(mx,my,'-',color=coul,label="Moy/" + str(lissa) + " Pression",linewidth=2)
			else:
				plt.plot(x,y,'-',color=coul,label="Pression")
			plt.legend(loc='upper left')

			plt.subplot(133)
			x=np.array(histo1)
			y=np.array(histo3)
			coul="blue"
			miny=np.min(y)
			maxy=np.max(y)
			plt.ylabel("H%",color=coul)
			plt.ylim(miny-5,maxy+5)
			plt.grid(which='major',axis='x',linewidth=1,linestyle='dashed',color='black')
			plt.grid(which='major',axis='y',linewidth=1,linestyle='-',color=coul)
			if lissa > 0:
				mx,my=Lissage(x,y,lissa)
				plt.plot(x,y,'-',color='grey',label="Humidité")
				plt.plot(mx,my,'-',color=coul,label="Moy/" + str(lissa) + " Humidité",linewidth=2)
			else:
				plt.plot(x,y,'-',color=coul,label="Humidité")
			plt.legend(loc='upper left')

	def GRAPHE1(ori,g):
		if len(histo1) > lissa:
			plt.subplot()
			x=np.array(histo1)
			if g == 1:
				y=np.array(histo2)
				coul="green"
				typ="Pression"
				unit="hPa"
				ech=5
			elif g == 2:
				y=np.array(histo3)
				coul="blue"
				typ="Humidité"
				unit="%"
				ech=5
			elif g == 3:
				y=np.array(histo4)
				coul="red"
				typ="Température"
				unit="°C"
				ech=1
			miny=min(y)
			maxy=max(y)
			plt.ylabel(unit,color=coul)
			plt.ylim(miny-ech,maxy+ech)
			plt.grid(which='major',axis='x',linewidth=1,linestyle='dashed',color='black')
			plt.grid(which='major',axis='y',linewidth=1,linestyle='-',color=coul)
			plt.suptitle(ori + "  Historique du " + str(x[0]) + "  au " + str(x[len(x)-1]) + "  [" + str(len(x)) + " points]",fontsize=12,fontweight='bold')
			if lissa > 0:
				mx,my=Lissage(x,y,lissa)
				plt.plot(x,y,'-',color='grey',label=typ,linewidth=1)
				plt.plot(mx,my,'-',color=coul,label="Moy/" + str(lissa) + " " + typ,linewidth=2,linestyle='-')
			else:
				plt.plot(x,y,'-',color=coul,label=typ,linewidth=2)
			plt.legend(loc='upper left')

	global fig1
	#Lissage auto
	lissa = VarMOY.get()

	if scrW < 1900:
		fig1=plt.figure(constrained_layout=True,figsize=(12,4),dpi=60)
	else:
		fig1=plt.figure(constrained_layout=True,figsize=(16,4),dpi=60)
	if TypeG.get() == 0:
		spec=gridspec.GridSpec(ncols=3,nrows=1,figure=fig1)
		G1=fig1.add_subplot(spec[0,0])
		G2=fig1.add_subplot(spec[0,1])
		G3=fig1.add_subplot(spec[0,2])
		G1.xaxis.set_major_locator(ticker.MaxNLocator(4))
		G2.xaxis.set_major_locator(ticker.MaxNLocator(4))
		G3.xaxis.set_major_locator(ticker.MaxNLocator(4))
		GRAPHE3(ori)
	else:
		spec=gridspec.GridSpec(ncols=1,nrows=1,figure=fig1)
		G1=fig1.add_subplot(spec[0,0])
		G1.xaxis.set_major_locator(ticker.MaxNLocator(12))
		GRAPHE1(ori,TypeG.get())

	"""Detection si PI400
	ip=get_LocalIP()
	cmd=[ip,capt[c][1],capt[c][2],[]]
	if SSH.Type_Raspi(cmd) == "Pi400":
		#print ("PI400")
		plt.draw()		#PI-400
	else:
		#print ("NORMAL")
		plt.ioff()
		plt.show()		#RPI normal """
	plt.ioff()
	plt.show()
	plt.pause(0.1)

def Lissage(Lx,Ly,lissa):
	Lxout=[]
	Lyout=[]
	for i in range(0,len(Ly)-lissa):
		moy=np.mean(Ly[i : i+lissa])
		Lxout.append (Lx[i])
		Lyout.append(moy)
	for i in range (len(Ly)-lissa+1,len(Ly)-1):
		moy=np.mean(Ly[i : i+lissa-1])
		Lxout.append (Lx[i])
		Lyout.append(moy)
	return Lxout,Lyout

def Fermer():
	global flagRUN
	ENR_Config()
	flagRUN=False

def ModeSimple():
	global flagRUN,flagSimple
	if os.path.exists(fichierSIMPLE):
		flagRUN=False
		flagSimple=True
		Fermer()
	else:
		bouSIMP.config(text="Existe Pas !")


def ENR_Config():
	if NBcapt.get() == 6:
		f=sys.path[0] + "/ThermoM6.conf"
		ConfDATA= {
			'cycle': VarCycle.get(),
			'capt0': str(VarCapt[0].get()),
			'capt1': str(VarCapt[1].get()),
			'capt2': str(VarCapt[2].get()),
			'capt3': str(VarCapt[3].get()),
			'capt4': str(VarCapt[4].get()),
			'capt5': str(VarCapt[5].get()),
			'maxcpu': str(maxTcpu.get()),
			} 
	else:
		f=sys.path[0] + "/ThermoM12.conf"
		ConfDATA= {
			'cycle': VarCycle.get(),
			'capt0': str(VarCapt[0].get()),
			'capt1': str(VarCapt[1].get()),
			'capt2': str(VarCapt[2].get()),
			'capt3': str(VarCapt[3].get()),
			'capt4': str(VarCapt[4].get()),
			'capt5': str(VarCapt[5].get()),
			'capt6': str(VarCapt[6].get()),
			'capt7': str(VarCapt[7].get()),
			'capt8': str(VarCapt[8].get()),
			'capt9': str(VarCapt[9].get()),
			'capt10': str(VarCapt[10].get()),
			'capt11': str(VarCapt[11].get()),
			'maxcpu': str(maxTcpu.get()),
			}
	nF=open(f,'wb')
	pickle.dump(ConfDATA,nF)
	nF.close()

def LIRE_Config():
	global capt,maxTcpu,lab1
	capt=[]
	if NBcapt.get() == 6:
		f=sys.path[0] + "/ThermoM6.conf"
	else:
		f=sys.path[0] + "/ThermoM12.conf"
	if os.path.exists(f):
		nF=open(f,'rb')
		ConfDATA=pickle.load(nF)
		nF.close()
		VarCycle.set(ConfDATA['cycle'])
		maxTcpu.set(ConfDATA['maxcpu'])
		for i in range (0,NBcapt.get()):
			cle="capt" + str(i)
			VarCapt[i].set(ConfDATA[cle])
			"""On reforme un tuple à partir de la chaine
			On vérifit si le dernier champ 4 INFO est rempli
			on ajoute le champ 5 vide """
			capt.append(list(map(str,VarCapt[i].get().split(" "))))
			if len(capt[i]) > 1:
				if len(capt[i]) == 4:	#Ajoute le champ4
					capt[i].append("")
				capt[i].append([])		#Ajoute le champ5
				if capt[i][4] != "":
					lab1[i].config(text=capt[i][4])
				else:
					lab1[i].config(text="CAPTEUR " + str(i))
			else:
				lab1[i].config(text="Non Défini")
		return True
	else:
		return False

def Lire_CNF():
	global fenTXT
	if fenTXT != None:
		 fenTXT.destroy()
		 fenTXT = None
		 return

	Affi_fenTXT()
	if NBcapt.get() == 6:
		f=sys.path[0] + "/ThermoM6.conf"
	else:
		f=sys.path[0] + "/ThermoM12.conf"
	if os.path.exists(f):
		with open(f,'rb') as nF:
			ConfDATA=pickle.load(nF)
		affiT.insert(END,"Cycle " + str(ConfDATA['cycle']) + '\n')
		affiT.insert(END,"Max CPU " + str(ConfDATA['maxcpu']) + '\n')
		for i in range (0,NBcapt.get()):
			cle="capt" + str(i)
			affiT.insert(END,str(ConfDATA[cle]) + '\n')
		affiT.update()
	else:
		affiT.insert(END,"PAS DE FICHIER: " + f)
	affiT.update()

def Valid(e):
	ENR_Config()
	sleep(0.1)
	LIRE_Config()

def TEST():
	global flagACQ,NOMraspi
	flagACQ=False
	EFFACE()
	Voyant('magenta')
	bouACQ.config(text='LANCER',state=DISABLED,fg='lightgrey')
	host=get_nom()
	NOMraspi=[]

	for i in range(0,NBcapt.get()):
		labCPU[i].config(text="Nom")
		labCPUT[i].config(text="Temp")
		check[i].set(0)
		Check[i].config(bg='lightgrey')

	for i in range(0,NBcapt.get()):
		try:
			cmd=[capt[i][0],capt[i][1],capt[i][2],[]]
			nom=SSH.Nom_Raspi(cmd)
			if nom == "":
				NOMraspi.append("")
				labCPU[i].config(text="Non Présent")
				labCPUT[i].config(text="---")
				check[i].set(0)
				Check[i].config(bg='pink')
				bouVNC[i].config(state=DISABLED)
				bouHISTO[i].config(state=DISABLED)
				bouRAZ[i].config(state=DISABLED)
			else:
				NOMraspi.append(nom)
				labCPU[i].config(text=nom)
				check[i].set(1)
				Check[i].config(bg='lightgreen')
				if nom == host:
					bouVNC[i].config(state=DISABLED)
					bouVNC[i].config(text='Local')
					labCPU[i].config(font=('Arial',11,'bold underline'))
				else:
					bouHISTO[i].config(state=NORMAL)
					bouVNC[i].config(text='VNC')
					labCPU[i].config(fg='blue')
		except:
			NOMraspi.append("")
			bouVNC[i].config(state=DISABLED)
			bouRAZ[i].config(state=DISABLED)
			bouHISTO[i].config(state=DISABLED)
			labCPUT[i].config(text="")
			check[i].set(0)
			Check[i].config(bg='red')
		can0.update()

	bouACQ.config(text='LANCER',state=NORMAL,fg='green')
	fen1.update()

def EFFACE():
	for i in range(0,NBcapt.get()):
		labCaptP1[i].config(text="---")
		labCaptP2[i].config(text="---")
		labCaptH[i].config(text="---")
		labCaptT[i].config(text="---")
		labMin[i].config(text="Tmin:")
		labMax[i].config(text="Tmax:")
		labMinD[i].config(text="---")
		labMaxD[i].config(text="---")
		labHeure[i].config(text="---")

def RAZ_MinMax(n):
	if check[n].get():
		f=str(capt[n][3]) + "ThermoMM.dat"
		c="sudo rm -rf " + str(f)
		cmd=[]
		cmd.append (capt[n][0])	#IP destination
		cmd.append (capt[n][1])	#Utilisateur
		cmd.append (capt[n][2])	#Passe
		cmd.append (c)			#Commande
		cmd.append ("")			#
		cmd.append ("")			#
		r=SSH.COMMAND(cmd)
		sleep(0.01)
		labMin[n].config(text="Tmin:")
		labMax[n].config(text="Tmax:")
		labMinD[n].config(text="***")
		labMaxD[n].config(text="***")

def Voyant(coul):
	can0.itemconfig(voy,fill=coul)
	fen1.update()

def curseur_main(e) :
	fen1.config(cursor='hand2')

def curseur_fleche(e) :
	fen1.config(cursor='arrow')

def Affi_fen1(w,h):
	global fen1,can0,can1,voy,listMH
	global bouHISTO,bouSIMP
	global labCPU,labCPUT,Check
	global bouACQ,bouVNC,bouRAZ
	global lab1,labCaptP1,labCaptP2,labCaptH,labCaptT,labMin,labMinD,labMax,labMaxD,labHeure
	global maxTcpu,labCONF
	x0=int((scrW-w)/2)
	y0=int((scrH-h)/4)
	fen1.geometry(str(w) +"x" + str(h) + "+" + str(x0) + "+" + str(y0))
	fen1.resizable(width=False, height=False)
	fen1.protocol("WM_DELETE_WINDOW",Fermer)
	fen1.config(bg='lightgreen')
	n=get_nom()
	fen1.title(n + " >> " + ver)

	EntreeCAPT=[]
	labCPU=[]
	labCPUT=[]
	Check=[]
	bouHISTO=[]
	bouVNC=[]
	bouRAZ=[]
	lab1=[]
	labCaptP1=[]
	labCaptP2=[]
	labCaptH=[]
	labCaptT=[]
	labMin=[]
	labMax=[]
	labMinH=[]
	labMaxH=[]
	labHeure=[]

	can0H=285
	can0 = Canvas(fen1,bg='lightgrey',
		highlightthickness=1,highlightbackground="blue",
		relief='solid',width=w-18,height=can0H)
	can0.place(x=8,y=8)

	labCY=Label(can0,text='Cycle (s)',bg='lightgrey',font=('Arial',10))
	labCY.place(x=10,y=8)
	EntreeCY=Spinbox(can0,from_=10,to=180,textvariable=VarCycle,font=("Arial",12),width=3,bg="white")
	EntreeCY.place(x=70,y=8)
	EntreeCY.bind("<Return>",Valid)

	voy=can0.create_oval(45,45,70,70,width=2,fill='white')

	bouTEST= Button(can0,text="Test.COM",width=10,command=TEST,font=('Arial',10,'bold'),fg='magenta')
	bouTEST.place(x=15,y=80,height=25)
	bouTEST.bind("<Enter>",curseur_main)
	bouTEST.bind("<Leave>",curseur_fleche)

	bouACQ= Button(can0,text="LANCER",state=DISABLED,width=8,command=ACQ,font=('Arial',12,'bold'))
	bouACQ.place(x=15,y=110,height=30)
	bouACQ.bind("<Enter>",curseur_main)
	bouACQ.bind("<Leave>",curseur_fleche)

	bouFerme= Button(can0,text="FERMER",width=8,command=Fermer,font=('Arial',12,'bold'),fg='blue')
	bouFerme.place(x=15,y=150,height=30)
	bouFerme.bind("<Enter>",curseur_main)
	bouFerme.bind("<Leave>",curseur_fleche)

	if logo != None:
		can0.create_image(60,210,image=logo,tag="cdl")
		can0.tag_bind("cdl","<ButtonRelease>",NOTICE)
		can0.tag_bind("cdl","<Enter>",curseur_main)
		can0.tag_bind("cdl","<Leave>",curseur_fleche)
	else:
		bouLOGO= Button(can0,text="AIDE",width=8,command=partial(NOTICE,0),font=('Arial',12,'bold'),fg='black')
		bouLOGO.place(x=15,y=190,height=30)
		bouLOGO.bind("<Enter>",curseur_main)
		bouLOGO.bind("<Leave>",curseur_fleche)

	labTE=Label(can0,text='Ecran:' + str(scrW) + 'x' + str(scrH),bg='lightgrey',fg='black',font=('Arial',10))
	labTE.place(x=10,y=240)
	
	labCONF=Label(can0,text='CONFIG',bg='lightgrey',fg='black',font=('Arial',10))
	labCONF.place(x=10,y=260)

	labTCPU=Label(can0,text='Temp Max CPU',bg='lightgrey',fg='black',font=('Arial',10))
	labTCPU.place(x=w-260,y=20)
	EntreeTCPU=Spinbox(can0,from_=30,to=60,textvariable=maxTcpu,font=("Arial",14),width=3,bg="lightgrey",fg='blue')
	EntreeTCPU.place(x=w-140,y=20)
	
	choixNBC1=Radiobutton(can0,text='6 Capteurs',variable=NBcapt,value=6,bg='lightgrey',fg='black',font=('Arial',12))
	choixNBC1.place(x=w-270,y=60)
	choixNBC1.bind("<ButtonRelease-1>",Change_NBcapt)
	choixNBC2=Radiobutton(can0,text='12 Capteurs',variable=NBcapt,value=12,bg='lightgrey',fg='black',font=('Arial',12))
	choixNBC2.place(x=w-150,y=60)
	choixNBC2.bind("<ButtonRelease-1>",Change_NBcapt)

	bouCHE= Button(can0,text="Fichier CHE",width=12,command=Lire_CHE,font=('Arial',12),fg='blue')
	bouCHE.place(x=w-230,y=100,height=30)
	bouCHE.bind("<Enter>",curseur_main)
	bouCHE.bind("<Leave>",curseur_fleche)

	bouCONF= Button(can0,text="Fichier Config" + str(NBcapt.get()),width=12,command=Lire_CNF,font=('Arial',12),fg='blue')
	bouCONF.place(x=w-230,y=145,height=30)
	bouCONF.bind("<Enter>",curseur_main)
	bouCONF.bind("<Leave>",curseur_fleche)

	bouSIMP= Button(can0,text="Mode Simple",width=12,command=ModeSimple,font=('Arial',12),fg='blue')
	bouSIMP.place(x=w-230,y=200,height=30)
	bouSIMP.bind("<Enter>",curseur_main)
	bouSIMP.bind("<Leave>",curseur_fleche)

	ty=5
	for i in range(0,NBcapt.get()):
		EntreeCAPT.append(Entry(can0,textvariable=VarCapt[i],font=("Arial",10),width=80,bg="white"))
		EntreeCAPT[i].place(x=120,y=ty)
		EntreeCAPT[i].bind("<Return>",Valid)
		Check.append(Checkbutton(can0,text="CAP-" + str(i+1),variable=check[i]))
		Check[i].place(x=690,y=ty)
		labCPU.append(Label(can0,text="cpu-" + str(i),width=25,bg='lightgrey',fg='blue',font=('Arial',11,'bold'),anchor='w'))
		labCPU[i].place(x=770,y=ty,height=20)
		labCPUT.append(Label(can0,text="Tcpu-" + str(i),width=25,bg='lightgrey',fg='blue',font=('Arial',11,'bold'),anchor='w'))
		labCPUT[i].place(x=950,y=ty,height=20)
		ty +=23

	fra=LabelFrame(can0,text="HISTO",width=170,height=245,borderwidth=1,relief='solid',bg='lightgrey',fg='black',font=('Arial',10))
	fra.place(x=1050,y=15)
	fra.bind("<Enter>",curseur_main)
	fra.bind("<Leave>",curseur_fleche)

	listMH=Listbox(fra,width=10,height=13,font=('Arial',10),selectmode=SINGLE,relief='flat',bg='lightgrey')
	for item in ListeMois:
		listMH.insert(END,item)
	listMH.place(x=5,y=0)
	listMH.bind("<<ListboxSelect>>",MOIS_HISTO)
	
	EntreeAN=Spinbox(fra,from_=2020,to=2030,textvariable=VarAN,font=("Arial",14),width=5,bg="lightgrey",fg='blue')
	EntreeAN.place(x=90,y=0)

	choixG0=Radiobutton(fra,text='Tout',variable=TypeG,value=0,bg='lightgrey',fg='black',font=('Arial',10))
	choixG0.place(x=80,y=30)
	choixG1=Radiobutton(fra,text='Press',variable=TypeG,value=1,bg='lightgrey',fg='black',font=('Arial',10))
	choixG1.place(x=80,y=47)
	choixG2=Radiobutton(fra,text='Humi',variable=TypeG,value=2,bg='lightgrey',fg='black',font=('Arial',10))
	choixG2.place(x=80,y=64)
	choixG3=Radiobutton(fra,text='Temp',variable=TypeG,value=3,bg='lightgrey',fg='black',font=('Arial',10))
	choixG3.place(x=80,y=81)

	moy0=Radiobutton(fra,text="Moy/0",variable=VarMOY,value=0,bg='lightgrey',fg='black',font=('Arial',10))
	moy0.place(x=80,y=120)
	moy3=Radiobutton(fra,text="Moy/3",variable=VarMOY,value=3,bg='lightgrey',fg='black',font=('Arial',10))
	moy3.place(x=80,y=140)
	moy10=Radiobutton(fra,text="Moy/10",variable=VarMOY,value=10,bg='lightgrey',fg='black',font=('Arial',10))
	moy10.place(x=80,y=160)
	moy20=Radiobutton(fra,text="Moy/20",variable=VarMOY,value=20,bg='lightgrey',fg='black',font=('Arial',10))
	moy20.place(x=80,y=180)
	moy50=Radiobutton(fra,text="Moy/50",variable=VarMOY,value=50,bg='lightgrey',fg='black',font=('Arial',10))
	moy50.place(x=80,y=200)

	can1=[]
	lab1=[]
	labP1=[]
	labP2=[]
	labH=[]
	labT=[]
	labHeu=[]
	labMin=[]
	labMax=[]
	labMinD=[]
	labMaxD=[]

	for i in range(0,NBcapt.get()):
		tx=3
		ty=5
		coul='lightyellow'
		can1.append(Canvas(fen1,bg=coul,bd=tx))
		can1[i].configure(relief='solid',width=240,height=260,bd=1,highlightthickness=1,highlightbackground="blue")
		if i <= 5:
			can1[i].place(x=8+(250*(i)),y=can0H+15)
		else:
			can1[i].place(x=8+(250*(i-6)),y=can0H+285)

		lab1.append(Label(can1[i],text='=======',bg=coul,fg='blue',font=('Arial',10,'bold','underline')))
		lab1[i].place(x=tx,y=ty+2)

		ty+=30
		labP1.append(Label(can1[i],text='Pression:',bg=coul,fg='blue',font=('Arial',12)))
		labP1[i].place(x=tx,y=ty+2)
		labCaptP1.append(Label(can1[i],bg=coul,fg='blue',font=('Arial',18)))
		labCaptP1[i].place(x=tx+80,y=ty)

		ty+=30
		labP2.append(Label(can1[i],text='Pression:',bg=coul,fg='blue',font=('Arial',12)))
		labP2[i].place(x=tx,y=ty+2)
		labCaptP2.append(Label(can1[i],bg=coul,fg='blue',font=('Arial',18)))
		labCaptP2[i].place(x=tx+80,y=ty)

		ty+=30
		labH.append(Label(can1[i],text='Humidité Rel:',bg=coul,fg='blue',font=('Arial',12)))
		labH[i].place(x=tx,y=ty+2)
		labCaptH.append(Label(can1[i],bg=coul,fg='blue',font=('Arial',18)))
		labCaptH[i].place(x=tx+120,y=ty)

		ty+=30
		labT.append(Label(can1[i],text='Température:',bg=coul,fg='blue',font=('Arial',12)))
		labT[i].place(x=tx,y=ty+2)
		labCaptT.append(Label(can1[i],bg=coul,fg='blue',font=('Arial',18)))
		labCaptT[i].place(x=tx+120,y=ty)

		ty+=30
		labHeu.append(Label(can1[i],text='Heure:',bg='lightyellow',fg='blue',font=('Arial',12)))
		labHeu[i].place(x=tx,y=ty+2)
		labHeure.append(Label(can1[i],text='----',bg='lightyellow',fg='blue',font=('Arial',18)))
		labHeure[i].place(x=tx+80,y=ty)

		ty+=40
		can1[i].create_line(5,ty,240,ty,width=2,fill='grey')
		labMin.append(Label(can1[i],text='Tmin: ----',bg=coul,fg='blue',font=('Arial',12)))
		labMin[i].place(x=tx,y=ty+5)
		labMinD.append(Label(can1[i],text='----',bg=coul,fg='blue',font=('Arial',10)))
		labMinD[i].place(x=tx+100,y=ty+5)
		labMax.append(Label(can1[i],text='Tmax: ----',bg=coul,fg='blue',font=('Arial',12)))
		labMax[i].place(x=tx,y=ty+30)
		labMaxD.append(Label(can1[i],text='----',bg=coul,fg='blue',font=('Arial',10)))
		labMaxD[i].place(x=tx+100,y=ty+30)

		can1[i].create_line(175,ty,175,ty+70,width=2,fill='grey')
		bouHISTO.append(Button(can1[i],text="HISTO",command=partial(Lire_HISTO,i),font=('Arial',10),bg='yellow'))
		bouHISTO[i].place(x=185,y=ty+5,width=50,height=18)
		bouHISTO[i].bind("<Enter>",curseur_main)
		bouHISTO[i].bind("<Leave>",curseur_fleche)

		bouVNC.append(Button(can1[i],text="VNC",command=partial(VNC,i),font=('Arial',10),bg='yellow'))
		bouVNC[i].place(x=185,y=ty+25,width=50,height=18)
		bouVNC[i].bind("<Enter>",curseur_main)
		bouVNC[i].bind("<Leave>",curseur_fleche)
		
		bouRAZ.append(Button(can1[i],text="<RAZ",command=partial(RAZ_MinMax,i),font=('Arial',10),bg='yellow'))
		bouRAZ[i].place(x=185,y=ty+45,width=50,height=18)
		bouRAZ[i].bind("<Enter>",curseur_main)
		bouRAZ[i].bind("<Leave>",curseur_fleche)

	fen1.update()

def Affi_fenTXT():
	global fenTXT,affiT
	fenTXT=Toplevel(fen1)
	fenTXT.overrideredirect(True)		#Pas de barre Titre
	x=lab1[0].winfo_rootx()
	y=lab1[0].winfo_rooty()-5
	fenTXT.geometry("500x300" + '+' + str(x) + '+' + str(y))
	fenTXT.config(bg='grey',relief='solid',bd=2)
	affiT=ScrolledText(fenTXT,bg='white',width=65,height=14,border=1,font=("Arial",10),fg='black',relief='solid')
	affiT.configure(wrap=WORD,autoseparators=True)
	affiT.place(x=10,y=10)
	fenTXT.update()

def ACQ():
	global flagACQ
	ENR_Config()
	flagACQ = not flagACQ
	if flagACQ:
		EFFACE()
		bouACQ.config(text="ARRET",fg='red')
	else:
		bouACQ.config(text="LANCER",fg='green')
	fen1.update()

def Change_NBcapt(e):
	global fenTXT
	if fenTXT != None:
		fenTXT.destroy()
		fenTXT = None
	#Suppression des canvas capteurs si existent
	try:
		for i in range(0,len(can1)):
			can1[i].destroy()
	except:
		pass
	for i in range(0,NBcapt.get()+1):
		VarCapt.append(StringVar())
		check.append(IntVar())
	if NBcapt.get() == 6:
		w=10+int(250*NBcapt.get())
		h=575
		conf="Config6"
	else:
		w=10+int(250*(NBcapt.get())/2)
		h=840
		conf="Config12"
	Affi_fen1(w,h)
	if not LIRE_Config():
		labCONF.configure(text="Erreur " +  conf,fg='red')
		VarCycle.set(20)
		maxTcpu.set(50)
	else:
		labCONF.configure(text= conf + " OK")
	TEST()

def Lire_CHE():
	global fenTXT
	def ENR_CHE():
		global fenTXT
		t=affiT.get('0.0',END)
		t=t[:len(t)-1]
		with open(fichierCHE,'w',encoding='utf-8') as nF:
			nF.write(t)
		fenTXT.destroy()
		fenTXT = None

	if fenTXT != None:
		 fenTXT.destroy()
		 fenTXT = None
		 return
	Affi_fenTXT()
	if os.path.exists(fichierCHE):
		bouENR=Button(fenTXT,text="ENREGISTRER",command=ENR_CHE,font=('Arial',10),bg='lightgrey')
		bouENR.place(x=165,y=250,width=150,height=20)
		labINF=Label(fenTXT,text='ATTENTION...Ce Fichier doit etre sur tous les RPI-THERMO',bg='grey',fg='blue',font=('Arial',10,'bold'))
		labINF.place(x=20,y=270)
		fenTXT.update()

		with open(fichierCHE,'r') as nf:
			l=nf.readlines()
		for i in l:
			affiT.insert(END,i)
	else:
		affiT.insert(END,"Pas de Fichier:\n" + fichierCHE)
	affiT.update()

#=============================================================================================================================
fen1 = Tk()
tscreen=Taillescreen()
scrW=int(tscreen[0])
scrH=int(tscreen[1])

#Démarre en 6 ou 12 Capteurs
if len(sys.argv) >= 2:
	nb = int(sys.argv[1])
else:
	nb=6			#6 capteurs par défaut
if nb<6:nb=6
if nb >6:nb=12
NBcapt=IntVar()		#6 ou 12 capteurs
NBcapt.set(nb)

VarCycle=IntVar()
VarCapt=[]
check=[]
TypeG=IntVar()
VarMOY=IntVar()
VarAN=StringVar()
maxTcpu=IntVar()

ListeMois=['ANNEE :','Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Aout','Septembre','Octobre','Novembre','Décembre']
MoisHisto=int(datetime.now().strftime('%m'))
VarAN.set(datetime.now().strftime('%Y'))
icon1=sys.path[0] + "/Icone1.gif"
icon2=sys.path[0] + "/Icone2.png"
fichierSIMPLE=sys.path[0] + "/Thermo-Maitre-Simple-202.py"
fichierCHE=sys.path[0] + "/ThermoCHE.txt"

flagRUN=True
Tmin=[50,"",""]
Tmax=[-50,"",""]
TypeG.set(3)        #met sur Temperature
VarMOY.set(0)		#pas de moyenne sur Histo
flagAPP=False       #Affiche ou non A propos
flagACQ=False       #True=lecture des capteurs en cours
fenTXT = None		#Affichage de fichier texte
flagSimple=False

logo=None
if os.path.exists(icon1):
	logo=PhotoImage(file=icon1)
else:
	if os.path.exists(icon2):
		logo=PhotoImage(file=icon2)

Change_NBcapt(0)	#Affiche selon nombre de capteurs

#========================================================================================================
while flagRUN:
	if flagACQ:
		Voyant('red')
		CDE_Temp()
		EFFACE()
		for i in range(0,NBcapt.get()): Lire_EXT(i)

		t=time.time() + VarCycle.get()
		tv=time.time()
		while t > tv:
			if flagRUN and flagACQ and fen1 != None:
				if time.time() > tv+1:
					Voyant('yellow')
					tv=time.time()
				else:
					Voyant('grey')
				sleep(0.5)
			else:
				break
	else:
		Voyant('grey')
		sleep(0.1)

fen1.quit()
if flagSimple:
	if NBcapt.get() == 6:
		cmd="python3 " + fichierSIMPLE + " &"
	else:
		cmd="python3 " + fichierSIMPLE + " 12 &"
	call(cmd,shell=True)


