#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
#  Thermo-Maitre-Simple-202
#  Affichage Simple
"""
Version 2.0.2   Mai 2022
Lecture sur plusieurs Raspi en SSH
Transfert des données par le fichier Thermo.dat
	0=Heure
	1=Config du capteur
	2=Pression hpa
	3=Pression cm
	4=Humidite
	5=Temperature
	6=Alarme Temperature
	7=Localisation
ENR MIN/MIN
	Fichier ThermoMM.dat
	0=Temp Min
	1=Date
	2=Heure
	3=Temp Max
	4=date
	5=heure
"""
import os,sys
import time
from time import sleep
from datetime import datetime
from tkinter import *
from tkinter import messagebox
from tkinter.scrolledtext import *
import subprocess
from subprocess import call
import pickle
from functools import partial

ver='Thermo-Maitre-Simple-2.0.2'
"""Librairie générale"""
sys.path.append (sys.path[0] + "/Lib")
from Lib import clsSSH
SSH=clsSSH.SSH()

def Taillescreen():
	sc=os.popen("xrandr -d :0").readlines(1)[0]
	w=sc.split()[7]
	h=sc.split()[9][:-1]
	return int(w),int(h)

def get_nom():
	r = str(subprocess.check_output("hostname", shell=True).decode('utf-8'))
	return r[:len(r)-1]

def EFFACE():
	for i in range(0,NBcapt.get()):
		labRPI[i].config(text="---")
		labCaptP1[i].config(text="---")
		labCaptP2[i].config(text="---")
		labCaptH[i].config(text="---")
		labCaptT[i].config(text="---")
		labHeure[i].config(text="---")

def Voyant(coul):
	can0.itemconfig(voy,fill=coul)
	fen1.update()

def Affi_fen1(w,h):
	global fen1,can0,can1,voy,labCY
	global labRPI,labCaptP1,labCaptP2,labCaptH,labCaptT,labHeure
	x0=int((scrW-w)/2)
	y0=int((scrH-h)/4)
	fen1.geometry(str(w) +"x" + str(h) + "+" + str(x0) + "+" + str(y0))
	fen1.resizable(width=False, height=False)
	fen1.protocol("WM_DELETE_WINDOW",Fermer)
	fen1.config(bg='lightgreen')
	n=get_nom()
	fen1.title(n + " >> " + ver)

	labRPI=[]
	labCaptP1=[]
	labCaptP2=[]
	labCaptH=[]
	labCaptT=[]
	labHeure=[]

	can0 = Canvas(fen1,bg='lightgrey',
		highlightthickness=1,highlightbackground="blue",
		relief='solid',width=w-7,height=35)
	can0.place(x=2,y=2)
	
	labCY=Label(can0,text='Cycle (s): ' + str(VarCycle.get()),bg='lightgrey',font=('Arial',12))
	labCY.place(x=10,y=5)
	voy=can0.create_oval(110,7,130,27,width=2,fill='white')
	bouREL= Button(can0,text="RELANCER",width=8,command=RELANCE,font=('Arial',10,'bold'),fg='magenta')
	bouREL.place(x=140,y=5,height=25)
	bouNORMA= Button(can0,text="NORMAL",width=6,command=ModeNormal,font=('Arial',10,'bold'),fg='black')
	bouNORMA.place(x=230,y=5,height=25)
	if NBcapt.get() == 6:
		t="Utilise ThermoM6 de Thermo-Maitre"
	else:
		t="Utilise ThermoM12 de Thermo-Maitre"
	labINF=Label(can0,text=t,bg='lightgrey',font=('Arial',10))
	labINF.place(x=305,y=5)
	if logo != None:
		can0.create_image(555,19,image=logo,tag="cdl")

	can1 = Canvas(fen1,bg='lightyellow',
		highlightthickness=1,highlightbackground="blue",
		relief='solid',width=w-7,height=h-55)
	can1.place(x=2,y=45)
	tx=3
	ty=5
	coul='lightyellow'

	labNOM=Label(can1,text='Nom Capteur',bg=coul,fg='black',font=('Arial',10,'bold'))
	labNOM.place(x=tx,y=ty)
	labP1=Label(can1,text='Pression',bg=coul,fg='black',font=('Arial',10,'bold'))
	labP1.place(x=tx+100,y=ty)
	labP2=Label(can1,text='Pression',bg=coul,fg='black',font=('Arial',10,'bold'))
	labP2.place(x=tx+200,y=ty)
	labH=Label(can1,text='Humidité Rel',bg=coul,fg='black',font=('Arial',10,'bold'))
	labH.place(x=tx+300,y=ty)
	labT=Label(can1,text='Température',bg=coul,fg='black',font=('Arial',10,'bold'))
	labT.place(x=tx+400,y=ty)
	labHeu=Label(can1,text='Heure',bg=coul,fg='black',font=('Arial',10,'bold'))
	labHeu.place(x=tx+500,y=ty)

	for i in range(0,NBcapt.get()):
		ty+=20
		labRPI.append(Label(can1,bg=coul,fg='blue',font=('Arial',11)))
		labRPI[i].place(x=tx,y=ty)
		
		labCaptP1.append(Label(can1,bg=coul,fg='blue',font=('Arial',11)))
		labCaptP1[i].place(x=tx+100,y=ty)

		labCaptP2.append(Label(can1,bg=coul,fg='blue',font=('Arial',11)))
		labCaptP2[i].place(x=tx+200,y=ty)

		labCaptH.append(Label(can1,bg=coul,fg='blue',font=('Arial',11)))
		labCaptH[i].place(x=tx+300,y=ty)

		labCaptT.append(Label(can1,bg=coul,fg='blue',font=('Arial',11)))
		labCaptT[i].place(x=tx+400,y=ty)

		labHeure.append(Label(can1,bg=coul,fg='blue',font=('Arial',11)))
		labHeure[i].place(x=tx+500,y=ty)
	fen1.update()

def Fermer():
	global flagRUN
	flagRUN=False
	
def LIRE_Config():
	global capt,lab1
	capt=[]
	if NBcapt.get() == 6:
		f=sys.path[0] + "/ThermoM6.conf"
	else:
		f=sys.path[0] + "/ThermoM12.conf"
	if os.path.exists(f):
		nF=open(f,'rb')
		ConfDATA=pickle.load(nF)
		nF.close()
		VarCycle.set(ConfDATA['cycle'])
		for i in range (0,NBcapt.get()):
			cle="capt" + str(i)
			VarCapt[i].set(ConfDATA[cle])
			"""On reforme un tuple à partir de la chaine
			On vérifit si le dernier champ 4 INFO est rempli
			on ajoute le champ 5 vide """
			capt.append(list(map(str,VarCapt[i].get().split(" "))))
			if len(capt[i]) > 1:
				if len(capt[i]) == 4:	#Ajoute le champ4
					capt[i].append("")
				capt[i].append([])		#Ajoute le champ5
		return True
	else:
		return False

def TEST():
	global flagACQ
	flagACQ=False
	Voyant('magenta')
	for i in range(0,NBcapt.get()):
		try:
			cmd=[capt[i][0],capt[i][1],capt[i][2],[]]
			nom=SSH.Nom_Raspi(cmd)
			check[i].set(bool(nom != ""))
		except:
			check[i].set(0)
	Voyant('grey')
	can0.update()

def RELANCE():
	global flagACQ
	flagACQ=False
	EFFACE()
	TEST()
	sleep(0.1)
	flagACQ=True

def ModeNormal():
	global flagRUN,flagSimple
	if os.path.exists(fichierNORMAL):
		flagRUN=False
		flagSimple=False
		Fermer()
	else:
		bouNORMA.config(text="Existe Pas !")

def Lire_EXT(source):
	Voyant('red')
	if check[source].get() == 0:
		labRPI[source].config(text="***")
		labCaptP1[source].config(text="***")
		labCaptP2[source].config(text="***")
		labCaptH[source].config(text="***")
		labCaptT[source].config(text="***")
		labHeure[source].config(text="***")

	else:
		capt[source][5]="Thermo.dat"
		try:
			d=SSH.Lire_tuple(capt[source],sep='|')
			if d[0] == "":
				labRPI[source].config(text=capt[source][4],font=('arial',10),fg='red')
				labCaptP1[source].config(text="---")
				labCaptP2[source].config(text="---")
				labCaptH[source].config(text="---")
				labCaptT[source].config(text="---")
				labHeure[source].config(text="---")
			else:
				h=" " + d[0]
				c="  (" + d[1] + ")"
				capt[source][4] = d[7]	#Localisation
				if capt[source][4] == "":
					capt[source][4]=NOMraspi[source]
				labRPI[source].config(text=capt[source][4],font=('arial',10),fg='black')
				labCaptP1[source].config(text=d[2] + " hPa")
				labCaptP2[source].config(text=d[3] + " cm")
				labCaptH[source].config(text=d[4] + " Hr%")
				if float(d[4][:-2]) > 70.0:
					labCaptH[source].config(fg='red')
				else:
					labCaptH[source].config(fg='blue')
				labCaptT[source].config(text=d[5] + " °c")
				if d[6] == "1":
					labCaptT[source].config(fg='magenta')
				else:
					labCaptT[source].config(fg='blue')
				labHeure[source].config(text=h)
				
		except:
			return
	Voyant('grey')
	fen1.update()
#=============================================================================================================================
fen1 = Tk()
tscreen=Taillescreen()
scrW=int(tscreen[0])
scrH=int(tscreen[1])

#Démarre en 6 ou 12 Capteurs
if len(sys.argv) >= 2:
	nb = int(sys.argv[1])
else:
	nb=6			#6 capteurs par défaut
NBcapt=IntVar()		#Nombre de capteurs
NBcapt.set(nb)

VarCycle=IntVar()
VarCapt=[]
check=[]
for i in range(0,NBcapt.get()):
	VarCapt.append(StringVar())
	check.append(IntVar())

icon=sys.path[0] + "/Cdpetit.gif"
flagRUN=True
flagACQ=False       #True=lecture des capteurs en cours
flagSimple=True		#mode simple
fichierNORMAL=sys.path[0] + "/Thermo-Maitre-202.py"

if os.path.exists(icon):
	logo=PhotoImage(file=icon)
else:
	logo=None

if NBcapt.get() == 6:
	h=210
else:
	h=325
Affi_fen1(590,h)
LIRE_Config()
labCY.config(text='Cycle (s): ' + str(VarCycle.get()))
TEST()

flagACQ=True

#========================================================================================================
while flagRUN:
	if flagACQ:
		Voyant('red')
		EFFACE()
		for i in range(0,NBcapt.get()): Lire_EXT(i)

		t=time.time() + VarCycle.get()
		tv=time.time()
		while t > tv:
			if flagRUN and flagACQ and fen1 != None:
				if time.time() > tv+1:
					Voyant('yellow')
					tv=time.time()
				else:
					Voyant('grey')
				sleep(0.5)
			else:
				break
	else:
		Voyant('grey')
		sleep(0.1)

fen1.quit()
if not flagSimple:
	if NBcapt.get() == 6:
		cmd="python3 " + fichierNORMAL + " &"
	else:
		cmd="python3 " + fichierNORMAL + " 12 &"
	call(cmd,shell=True)

